diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/model/three-gpp-channel-model.h ns-3.47/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.46/src/spectrum/model/three-gpp-channel-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/model/three-gpp-channel-model.h	2026-02-16 16:08:49.824230700 -0800
@@ -3,6 +3,7 @@
  * New York University
  * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
  * University of Padova
+ * Copyright (c) 2026, CTTC, Centre Tecnologic de Telecomunicacions de Catalunya
  *
  * SPDX-License-Identifier: GPL-2.0-only
  */
@@ -12,12 +13,8 @@
 
 #include "matrix-based-channel-model.h"
 
-#include "ns3/angles.h"
-#include "ns3/boolean.h"
 #include "ns3/channel-condition-model.h"
-#include "ns3/deprecated.h"
 
-#include <complex.h>
 #include <unordered_map>
 
 namespace ns3
@@ -26,13 +23,9 @@
 class MobilityModel;
 
 /**
- * @ingroup spectrum
- * @brief Channel Matrix Generation following 3GPP TR 38.901
- *
- * The class implements the channel matrix generation procedure
- * described in 3GPP TR 38.901.
- *
- * @see GetChannel
+ * ThreeGppChannelModel extends MatrixBasedChannelModel and represents a channel
+ * model based on 3GPP specifications, including functionality for
+ * managing channel conditions, scenarios, and frequency requirements.
  */
 class ThreeGppChannelModel : public MatrixBasedChannelModel
 {
@@ -92,7 +85,7 @@
     std::string GetScenario() const;
 
     /**
-     * Looks for the channel matrix associated to the aMob and bMob pair in m_channelMatrixMap.
+     * Looks for the channel matrix associated with the aMob and bMob pair in m_channelMatrixMap.
      * If found, it checks if it has to be updated. If not found or if it has to
      * be updated, it generates a new uncorrelated channel matrix using the
      * method GetNewChannel and updates m_channelMap.
@@ -109,8 +102,8 @@
                                         Ptr<const PhasedArrayModel> bAntenna) override;
 
     /**
-     * Looks for the channel params associated to the aMob and bMob pair in
-     * m_channelParamsMap. If not found it will return a nullptr.
+     * Looks for the channel params associated with the aMob and bMob pair in
+     * m_channelParamsMap. If not found, it will return a nullptr.
      *
      * @param aMob mobility model of the a device
      * @param bMob mobility model of the b device
@@ -127,13 +120,12 @@
      */
     int64_t AssignStreams(int64_t stream);
 
-  protected:
     /**
      * Wrap an (azimuth, inclination) angle pair in a valid range.
      * Specifically, inclination must be in [0, M_PI] and azimuth in [0, 2*M_PI).
-     * If the inclination angle is outside of its range, the azimuth angle is
+     * If the inclination angle is outside its range, the azimuth angle is
      * rotated by M_PI.
-     * This methods aims specifically at solving the problem of generating angles at
+     * This method aims specifically at solving the problem of generating angles at
      * the boundaries of the angle domain, specifically, generating angle distributions
      * close to inclinationRad=0 and inclinationRad=M_PI.
      *
@@ -147,71 +139,112 @@
      * Extends the struct ChannelParams by including information that is used
      * within the ThreeGppChannelModel class
      */
-    struct ThreeGppChannelParams : public MatrixBasedChannelModel::ChannelParams
+    struct ThreeGppChannelParams : ChannelParams
     {
-        ChannelCondition::LosConditionValue
-            m_losCondition; //!< contains the information about the LOS state of the channel
-        ChannelCondition::O2iConditionValue
-            m_o2iCondition; //!< contains the information about the O2I state of the channel
-        // TODO these are not currently used, they have to be correctly set when including the
-        // spatial consistent update procedure
-        /*The following parameters are stored for spatial consistent updating. The notation is
+        /// contains the information about the LOS state of the channel
+        ChannelCondition::LosConditionValue m_losCondition;
+        /// contains the information about the O2I state of the channel
+        ChannelCondition::O2iConditionValue m_o2iCondition;
+        /*The following parameters are stored for spatially consistent updating. The notation is
         that of 3GPP technical reports, but it can apply also to other channel realizations*/
-        MatrixBasedChannelModel::Double2DVector m_nonSelfBlocking; //!< store the blockages
-        Vector m_preLocUT; //!< location of UT when generating the previous channel
-        Vector m_locUT;    //!< location of UT
-        MatrixBasedChannelModel::Double2DVector
-            m_norRvAngles; //!< stores the normal variable for random angles angle[cluster][id]
-                           //!< generated for equation (7.6-11)-(7.6-14), where id =
-                           //!< 0(aoa),1(zoa),2(aod),3(zod)
-        double m_DS;       //!< delay spread
-        double m_K_factor; //!< K factor
-        uint8_t m_reducedClusterNumber; //!< reduced cluster number;
-        MatrixBasedChannelModel::Double2DVector
-            m_rayAodRadian; //!< the vector containing AOD angles
-        MatrixBasedChannelModel::Double2DVector
-            m_rayAoaRadian; //!< the vector containing AOA angles
-        MatrixBasedChannelModel::Double2DVector
-            m_rayZodRadian; //!< the vector containing ZOD angles
-        MatrixBasedChannelModel::Double2DVector
-            m_rayZoaRadian; //!< the vector containing ZOA angles
-        MatrixBasedChannelModel::Double3DVector m_clusterPhase; //!< the initial random phases
-        MatrixBasedChannelModel::Double2DVector
-            m_crossPolarizationPowerRatios; //!< cross polarization power ratios
-        Vector m_speed;                     //!< velocity
-        double m_dis2D;                     //!< 2D distance between tx and rx
-        double m_dis3D;                     //!< 3D distance between tx and rx
-        DoubleVector m_clusterPower;        //!< cluster powers
-        DoubleVector m_attenuation_dB;      //!< vector that stores the attenuation of the blockage
-        uint8_t m_cluster1st;               //!< index of the first strongest cluster
-        uint8_t m_cluster2nd;               //!< index of the second strongest cluster
+        /// store the blockages
+        Double2DVector m_nonSelfBlocking;
+        /** stores the normal variable for random angles angle[cluster][id]
+         * generated for equation (7.6-11)-(7.6-14), where id follows
+         * MatrixBasedChannelModel::{AOA,ZOA,AOD,ZOD}_INDEX ordering.
+         */
+        Double2DVector m_norRvAngles;
+        /// delay spread
+        double m_DS;
+        /// K factor
+        double m_K_factor;
+        /// reduced cluster number
+        uint8_t m_reducedClusterNumber;
+        /** The signs of the XN per cluster -1 or +1, per NLOS used in channel consistency procedure
+         */
+        std::vector<int> m_clusterXnNlosSign;
+        Double2DVector m_rayAodRadian;                 //!< the vector containing AOD angles
+        Double2DVector m_rayAoaRadian;                 //!< the vector containing AOA angles
+        Double2DVector m_rayZodRadian;                 //!< the vector containing ZOD angles
+        Double2DVector m_rayZoaRadian;                 //!< the vector containing ZOA angles
+        Double3DVector m_clusterPhase;                 //!< the initial random phases
+        Double2DVector m_crossPolarizationPowerRatios; //!< cross-polarization power ratios
+        double m_dis2D;                                //!< 2D distance between tx and rx
+        double m_dis3D;                                //!< 3D distance between tx and rx
+        DoubleVector m_clusterShadowing;               //!< cluster shadowing
+        DoubleVector m_clusterPower;                   //!< cluster powers
+        DoubleVector m_attenuation_dB;   //!< vector that stores the attenuation of the blockage
+        uint8_t m_cluster1st;            //!< index of the first strongest cluster
+        uint8_t m_cluster2nd;            //!< index of the second-strongest cluster
+        Vector m_txSpeed;                //!< TX velocity
+        Vector m_rxSpeed;                //!< RX velocity
+        DoubleVector m_delayConsistency; //!< cluster delay for consistency update
+        /**
+         * The effective 2D displacement used to determine whether a channel-consistency update
+         * can be applied, computed between consecutive endpoint positions.
+         *
+         * Since channel parameters are stored using a reciprocal key, endpoint-specific state is
+         * handled using a canonical ordering by node ID (min ID / max ID). The displacement is
+         * computed as the maximum of the two endpoint displacements since the last
+         * generation/update.
+         */
+        double m_endpointDisplacement2D{0.0};
+        /**
+         * 2D displacement of the canonical relative position vector between the two endpoints
+         * since the last generation/update.
+         *
+         * This corresponds to the change in the link geometry in the horizontal plane and is used
+         * by Procedure A updates that evolve cluster-level random variables as a function of
+         * displacement (e.g., per-cluster shadowing correlation).
+         */
+        double m_relativeDisplacement2D{0.0};
+        /**
+         * Position of the endpoint with the smallest node ID (canonical endpoint ordering) at the
+         * time of the last channel parameter generation/update.
+         */
+        Vector m_lastPositionFirst;
+        /**
+         * Position of the endpoint with the largest node ID (canonical endpoint ordering) at the
+         * time of the last channel parameter generation/update.
+         */
+        Vector m_lastPositionSecond;
+        /**
+         * Canonical 2D relative position vector (first -> second) stored at the time of the last
+         * channel parameter generation/update.
+         *
+         * This is used to compute m_relativeDisplacement2D as the 2D displacement of the link
+         * geometry between consecutive updates.
+         */
+        Vector2D m_lastRelativePosition2D;
     };
 
     /**
      * Data structure that stores the parameters of 3GPP TR 38.901, Table 7.5-6,
      * for a certain scenario
      */
-    struct ParamsTable : public SimpleRefCount<ParamsTable>
+    struct ParamsTable : SimpleRefCount<ParamsTable>
     {
         uint8_t m_numOfCluster = 0;   //!< Number of clusters
         uint8_t m_raysPerCluster = 0; //!< Number of rays per cluster
         double m_uLgDS = 0;           //!< Mean value of 10-base logarithm of delay spread
         double m_sigLgDS = 0; //!< Standard deviation value of 10-base logarithm of delay spread
-        double m_uLgASD =
-            0; //!< Mean value of 10-base logarithm of azimuth angle spread of departure
-        double m_sigLgASD =
-            0; //!< Standard deviation of 10-base logarithm of azimuth angle spread of departure
-        double m_uLgASA = 0; //!< Mean value of 10-base logarithm of azimuth angle spread of arrival
-        double m_sigLgASA =
-            0; //!< Standard deviation of 10-base logarithm of azimuth angle spread of arrival
-        double m_uLgZSA = 0; //!< Mean value of 10-base logarithm of zenith angle spread of arrival
-        double m_sigLgZSA =
-            0; //!< Standard deviation of 10-base logarithm of zenith angle spread of arrival
-        double m_uLgZSD =
-            0; //!< Mean value of 10-base logarithm of zenith angle spread of departure
-        double m_sigLgZSD =
-            0; //!< Standard deviation of 10-base logarithm of zenith angle spread of departure
-        double m_offsetZOD = 0;              //!< Offset of zenith angle of departure
+        //! Mean value of 10-base logarithm of azimuth angle spread of departure
+        double m_uLgASD = 0;
+        //! Standard deviation of 10-base logarithm of azimuth angle spread of departure
+        double m_sigLgASD = 0;
+        //! Mean value of 10-base logarithm of azimuth angle spread of arrival
+        double m_uLgASA = 0;
+        //! Standard deviation of 10-base logarithm of azimuth angle spread of arrival
+        double m_sigLgASA = 0;
+        //! Mean value of 10-base logarithm of zenith angle spread of arrival
+        double m_uLgZSA = 0;
+        //! Standard deviation of 10-base logarithm of zenith angle spread of arrival
+        double m_sigLgZSA = 0;
+        //! Mean value of 10-base logarithm of zenith angle spread of departure
+        double m_uLgZSD = 0;
+        //! Standard deviation of 10-base logarithm of zenith angle spread of departure
+        double m_sigLgZSD = 0;
+        double m_offsetZOD = 0;              //!< Offset of a zenith angle of departure
         double m_cDS = 0;                    //!< Cluster DS
         double m_cASD = 0;                   //!< Cluster ASD (Azimuth angle Spread of Departure)
         double m_cASA = 0;                   //!< Cluster ASA (Azimuth angle Spread of Arrival)
@@ -222,8 +255,22 @@
         double m_uXpr = 0;                   //!< Mean of Cross-Polarization Ratio
         double m_sigXpr = 0;                 //!< Standard deviation of Cross-Polarization Ratio
         double m_perClusterShadowingStd = 0; //!< Per cluster shadowing standard deviation
-        double m_sqrtC[7][7]; //!< The square root matrix and follows the order of [SF, K, DS, ASD,
-                              //!< ASA, ZSD, ZSA]
+        //! Correlation distance for spatial consistency (7.6.3.1-2) in meters.
+        //! Default value set to 1, because V2V and NTN models documentations do not provide this
+        //! parameter value
+        double m_perClusterRayDcorDistance = 1;
+        //! The spatial correlation distance for the random variable determining the centre of the
+        //! blocker in meters; Default value set to 1, because V2V and NTN models documentations do
+        //! not provide
+        // this parameter value
+        double m_blockerDcorDistance = 1;
+
+        /**
+         * For LOS, LSP is following the order of [SF,K,DS,ASD,ASA,ZSD,ZSA].
+         * For NLOS, LSP is following the order of [SF,DS,ASD,ASA,ZSD,ZSA].
+         * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+         */
+        double m_sqrtC[7][7];
     };
 
     /**
@@ -234,21 +281,62 @@
      * @return the parameters table
      */
     virtual Ptr<const ParamsTable> GetThreeGppTable(
-        const Ptr<const MobilityModel> aMob,
-        const Ptr<const MobilityModel> bMob,
+        Ptr<const MobilityModel> aMob,
+        Ptr<const MobilityModel> bMob,
         Ptr<const ChannelCondition> channelCondition) const;
 
+  protected:
+    /**
+     * Update distance- and displacement-related values between two nodes.
+     *
+     * The function computes the current 2D and 3D distances between two mobility models.
+     *
+     * It also computes two 2D displacement measures with respect to previously stored state.
+     * Since channel parameters are stored using a reciprocal key, endpoint-specific state is
+     * handled using a canonical ordering by node ID (min ID / max ID).
+     * ``endpointDisplacement2D`` is the maximum 2D displacement of the two endpoints since the last
+     * channel parameter generation/update.
+     * ``relativeDisplacement2D`` is the 2D displacement of the canonical relative position vector
+     * between the endpoints since the last generation/update.
+     *
+     * @param aMob The mobility model of the first node (unordered).
+     * @param bMob The mobility model of the second node (unordered).
+     * @param distance2D Output parameter that stores the 2D distance between the two nodes.
+     * @param distance3D Output parameter that stores the 3D distance between the two nodes.
+     * @param endpointDisplacement2D Output parameter that stores the effective 2D displacement
+     *        (in meters).
+     * @param relativeDisplacement2D Output parameter that stores the 2D displacement (in meters)
+     *        of the canonical relative position vector between the two endpoints since the last
+     *        channel parameter generation/update.
+     * @param lastPositionFirst Position of the endpoint with the smallest node ID at the time of
+     *        the last channel parameter generation/update.
+     * @param lastPositionSecond Position of the endpoint with the largest node ID at the time of
+     *        the last channel parameter generation/update.
+     * @param lastRelativePosition2D Previously stored canonical 2D relative position vector
+     *        (first endpoint minus second endpoint) at the time of the last channel parameter
+     *        generation/update.
+     */
+    void UpdateLinkGeometry(Ptr<const MobilityModel> aMob,
+                            Ptr<const MobilityModel> bMob,
+                            double* distance2D,
+                            double* distance3D,
+                            double* endpointDisplacement2D,
+                            double* relativeDisplacement2D,
+                            Vector* lastPositionFirst,
+                            Vector* lastPositionSecond,
+                            Vector2D* lastRelativePosition2D) const;
+
     /**
      * Prepare 3gpp channel parameters among the nodes a and b.
      * The function does the following steps described in 3GPP 38.901:
      *
-     * Step 4: Generate large scale parameters. All LSPS are uncorrelated.
+     * Step 4: Generate large scale parameters. All LSPs are uncorrelated.
      * Step 5: Generate Delays.
      * Step 6: Generate cluster powers.
      * Step 7: Generate arrival and departure angles for both azimuth and elevation.
      * Step 8: Coupling of rays within a cluster for both azimuth and elevation
      * shuffle all the arrays to perform random coupling
-     * Step 9: Generate the cross polarization power ratios
+     * Step 9: Generate the cross-polarization power ratios
      * Step 10: Draw initial phases
      *
      * All relevant generated parameters are added then to ThreeGppChannelParams
